#include <stdio.h>

#include <X11/Xlib.h>

void
main( argc, argv )
    int argc;
    char* argv[];
    {
    int argn, seconds;
    char *display_name;
    Display *display;
    char* usage = "usage:  %s [-display display] seconds\n";

    argn = 1;
    display_name = (char*) 0;

    while ( argn < argc && argv[argn][0] == '-' )
	{
	if ( strcmp( argv[argn], "-display" ) == 0 ||
	     strcmp( argv[argn], "-displa" ) == 0 ||
	     strcmp( argv[argn], "-displ" ) == 0 ||
	     strcmp( argv[argn], "-disp" ) == 0 ||
	     strcmp( argv[argn], "-dis" ) == 0 ||
	     strcmp( argv[argn], "-di" ) == 0 ||
	     strcmp( argv[argn], "-d" ) == 0 )
	    {
	    ++argn;
	    if ( argn >= argc )
		{
		(void) fprintf( stderr, usage, argv[0] );
		exit( 1 );
		}
	    display_name = argv[argn];
	    }
	}

    if ( argn >= argc )
	{
	(void) fprintf( stderr, usage, argv[0] );
	exit( 1 );
	}
    seconds = atoi( argv[argn] );
    if ( seconds <= 0 )
	{
	(void) fprintf( stderr, usage, argv[0] );
	exit( 1 );
	}
    ++argn;

    if ( argn != argc )
	{
	(void) fprintf( stderr, usage, argv[0] );
	exit( 1 );
	}

    display = XOpenDisplay( display_name );
    if ( display == (Display*) 0 )
	{
        fprintf(
	    stderr, "%s: can't open display \"%s\"\n",
	    argv[0], XDisplayName( display_name ) );
        exit(1);
	}
    
    sleep( seconds );

    XCloseDisplay( display );
    exit( 0 );
    }
